<template>
  <div class="content-box">
    <div class="left">
      <!-- <el-icon :size="23" class="camera"><VideoCameraFilled /></el-icon> -->
      <span class="cameratxt">车辆管理</span>
    </div>
    <div class="middle">
      <div class="filter">
        <div class="condition">
          <span>车牌 : </span>
          <el-input
            clearable
            v-model="searchInput.carnumber"
            class="w-50 m-2"
            placeholder="请输入车牌号"
            style="width: 150px"
          />
        </div>
        <div class="condition">
          <span>创建时间 : </span>
          <el-date-picker
            v-model="searchInput.createTime"
            type="date"
            format="YYYY-MM-DD"
            value-format="YYYY-MM-DD"
            :prefix-icon="Calendar"
            placeholder="请选择时间"
          />
        </div>

        <el-button
          style="margin-left: 20px"
          color="rgba(61, 81, 232, 1)"
          type="primary"
          class="search"
          @click="searchBtn"
          ><el-icon><Search /></el-icon> <span>查询</span></el-button
        >
        <el-button
          style="margin-left: 20px !important"
          color="rgba(61, 81, 232, 1)"
          type="primary"
          class="search"
          @click="searchRefresh"
          ><el-icon><Refresh /></el-icon><span>重置</span></el-button
        >
      </div>
      <!-- 按钮列表 -->
      <div class="gongneng">
        <el-button type="primary" color="rgba(61, 81, 232, 1)" @click="addlist"
          ><el-icon><CirclePlus /></el-icon><span>新增车辆</span></el-button
        >
        <el-button
          color="rgba(61, 81, 232, 1)"
          class="import"
          type="primary"
          @click="importExcel"
          ><img
            src="@/assets/import.png"
            style="width: 14px; height: 14px; margin-right: 4px"
            alt=""
          />
          <span>导出表单</span></el-button
        >
      </div>
    </div>
    <div class="footer">
      <el-table
        :row-class-name="tableRowClassName"
        :data="tableData.list"
        @selection-change="handleSelectionChange"
        style="width: 100%"
        :header-cell-style="{
          background: 'rgba(240, 243, 247, 1)',
          height: '50px',
          border: 0,
        }"
      >
        <!-- <el-table-column align="center" type="selection" width="80" /> -->
        <el-table-column
          width="150"
          align="center "
          prop="device_number"
          label="序列号"
        />
        <el-table-column align="center" prop="car_number" label="车牌" />
        <el-table-column
          align="center"
          prop="contain"
          label="容量"
          width="200"
        />

        <el-table-column align="center" prop="create_time" label="创建时间" />

        <el-table-column align="center" label="操作" width="220">
          <template #default="scope">
            <el-button link type="primary" @click="edit(scope.row)"
              ><div class="look">编辑</div></el-button
            >
            <el-button link type="danger" @click="del(scope.row)"
              ><div class="looks">删除</div></el-button
            >
          </template>
        </el-table-column>
      </el-table>

      <!-- 添加车辆弹窗 -->
      <el-dialog
        class="addStaff"
        v-model="addDialogVisible"
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        :title="dialongTitle"
        align-center
        width="609"
        :before-close="handleVideoClose"
      >
        <el-form
          ref="ruleFormRef"
          :model="ruleForm"
          :rules="rules"
          label-width="100px"
          class="demo-ruleForm"
          :size="formSize"
          label-position="left"
          status-icon
        >
          <el-form-item label="序列号 :" prop="serial">
            <el-input
              clearable
              v-model="ruleForm.serial"
              placeholder="请输入序列号"
            />
          </el-form-item>
          <el-form-item label="车牌 :" prop="buslicence">
            <el-input
              clearable
              v-model="ruleForm.buslicence"
              placeholder="请输入车牌"
            />
          </el-form-item>
          <el-form-item
            label="容量 :"
            prop="volume"
            style="
              padding-bottom: 40px;
              border-bottom: 1px solid rgba(230, 230, 230, 1);
            "
          >
            <el-input
              clearable
              v-model="ruleForm.volume"
              placeholder="请输入容量"
            />
          </el-form-item>

          <el-form-item class="options">
            <el-button class="congzhi" @click="cancelAdd(ruleFormRef)"
              >取消</el-button
            >
            <el-button
              color="rgba(61, 81, 232, 1)"
              class="queding"
              type="primary"
              @click="submitAdd(ruleFormRef)"
            >
              确定
            </el-button>
          </el-form-item>
        </el-form>
      </el-dialog>
    </div>

    <!-- 分页组件 -->
    <el-pagination
      background
      :current-page="currentPage"
      :page-size="pageSize"
      layout="total, prev, pager, next, jumper, slot"
      :total="total"
      @update:current-page="handleCurrentChange"
    />
  </div>
</template>

<script setup>
import { ref, reactive, nextTick, onBeforeMount, onUnmounted } from "vue";
import { useRouter } from "vue-router";
import { ElMessage, ElMessageBox } from "element-plus";
import { Calendar } from "@element-plus/icons-vue";
import vidiconsApi from "@/api/vidicons.js";
import { dayjs } from "element-plus";
import lodash from "lodash";
import axios from "axios";
import { useStore } from "vuex";
const store = useStore();
const api = ref("");
const router = useRouter();
// 表格数据
const tableData = reactive({ list: [] });
const activeIndex = ref(); // 默认跳转路由
const dialongTitle = ref("新增车辆"); // 弹窗标题

const searchInput = reactive({
  carnumber: "",
  createTime: "",
}); // 搜索按钮数据
5;

const currentPage = ref(1); // 当前页
const pageSize = ref(10);
const total = ref(); // 当前总数
const selectData = reactive({ list: [] }); // 多选框选择的数据

const addDialogVisible = ref(false); // 控制添加员工弹窗

// 表单数据
const formSize = ref("default");
const ruleFormRef = ref();
const ruleForm = reactive({
  serial: "",
  buslicence: "",
  volume: "",
  id: "",
});
// 表单验证
const rules = reactive({
  // serial: [{ required: true, message: "序列号不能为空", trigger: "blur" }],
  buslicence: [
    { required: true, message: "请输入车牌号", trigger: "blur" },
    {
      pattern:
        /^[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领A-Z]{1}[A-Z]{1}[A-Z0-9]{4}[A-Z0-9挂学警港澳]{1}$/,
      message: "请输入合法车牌号",
      trigger: "blur",
    },
  ],
  volume: [
    {
      required: true,
      message: "容量不能为空",
      trigger: "blur",
    },
    {
      pattern: /^(0|[1-9][0-9]*)$/,
      message: "请输入正确数字",
      trigger: "blur",
    },
  ],

  // desc: [{ required: true, message: "Please input activity form", trigger: "blur" }],
});
// 查看车辆管理列表
const getList = async (flag) => {
  let data = new FormData();
  if (searchInput.createTime == null) {
    searchInput.createTime = "";
  }
  data.set("car_number", searchInput.carnumber);
  data.set("create_time", searchInput.createTime); //前面的key记得对应！
  data.set("page", currentPage.value);
  data.set("rows", pageSize.value); //前面的key记得对应！
  // let res = await adminApi.adminLogin(data);
  let res = await axios({
    method: "post",
    url: api.value + "/carBook/cinfolist.action",
    headers: {
      token: sessionStorage.getItem("token"),
    },
    data: data,
  });
  console.log(res);
  if (res.status == 200) {
    tableData.list = res.data.rows;
    if (flag == 1) {
      sessionStorage.setItem("busSelect", JSON.stringify(tableData.list));
    }
    // currentPage.value = res.data.currentPage;
    total.value = res.data.total;
  } else {
    tableData.list = res.data.rows;
    currentPage.value = 1;
    total.value = res.data.total;
    ElMessage({
      type: "error",
      showClose: true,
      message: res.data.message,
      center: true,
    });
    if (res.data.message == "token错误") {
      router.push({
        path: `/login`,
      });
    }
  }
};

// 搜索功能
const searchBtn = lodash.debounce(async () => {
  getList("查询成功");
}, 300);
// 重置搜索
const searchRefresh = lodash.debounce(async () => {
  searchInput.carnumber = "";
  searchInput.createTime = "";
  currentPage.value = 1;
  getList();
}, 300);
//新增车辆
const addlist = () => {
  dialongTitle.value = "新增车辆";
  addDialogVisible.value = true;
  ruleForm.serial = "";
  ruleForm.buslicence = "";
  ruleForm.volume = "";
};
//编辑按钮
const edit = (row) => {
  dialongTitle.value = "编辑车辆";
  addDialogVisible.value = true;
  ruleForm.serial = row.device_number;
  ruleForm.buslicence = row.car_number;
  ruleForm.volume = row.contain;
  ruleForm.id = row.id;
};
// 取消新增车辆
const cancelAdd = () => {
  addDialogVisible.value = false;
  ruleFormRef.value.resetFields();
};
// 确认新增车辆
const submitAdd = async (formEl) => {
  if (!formEl) return;
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      if (dialongTitle.value == "新增车辆") {
        let data = {
          device_number: ruleForm.serial,
          car_number: ruleForm.buslicence,
          contain: ruleForm.volume,
        };
        // let res = await admin.adminAdd(data);
        let res = await axios({
          method: "post",
          url: api.value + "/carBook/cinfoinsert.action",
          headers: {
            "Content-Type": "application/json;charset=utf-8",
            token: sessionStorage.getItem("token"),
          },
          data: data,
        });
        // console.log(res, "添加账号");
        if (res.data.code == 200) {
          getList();
          store.dispatch("busNum");
          ElMessage({
            type: "success",
            showClose: true,
            message: res.data.message,
            center: true,
          });
          addDialogVisible.value = false;
          ruleFormRef.value.resetFields();
        } else {
          ElMessage({
            type: "error",
            showClose: true,
            message: res.data.message,
            center: true,
          });
        }
      } else {
        let data = {
          device_number: ruleForm.serial,
          car_number: ruleForm.buslicence,
          contain: ruleForm.volume,
          id: ruleForm.id,
        };
        // let res = await admin.adminAdd(data);
        let res = await axios({
          method: "post",
          url: api.value + "/carBook/cinfoupdate.action",
          headers: {
            "Content-Type": "application/json;charset=utf-8",
            token: sessionStorage.getItem("token"),
          },
          data: data,
        });
        // console.log(res, "修改账号");
        if (res.data.code == 200) {
          getList();
          store.dispatch("busNum");
          ElMessage({
            type: "success",
            showClose: true,
            message: res.data.message,
            center: true,
          });
          addDialogVisible.value = false;
          ruleFormRef.value.resetFields();
        } else {
          ElMessage({
            type: "error",
            showClose: true,
            message: res.data.message,
            center: true,
          });
        }
      }
    } else {
      console.log("error submit!", fields);
    }
  });
};

//删除按钮
const del = (row) => {
  ElMessageBox.confirm(`是否删除 ${row.car_number} 车?`, "提示", {
    confirmButtonText: "确认",
    cancelButtonText: "取消",
    type: "warning",
  })
    .then(async () => {
      let data = new FormData();
      data.set("id", row.id);
      // let res = await adminApi.adminLogin(data);
      let res = await axios({
        method: "post",
        url: api.value + "/carBook/cinfodel.action",
        headers: {
          token: sessionStorage.getItem("token"),
        },
        data: data,
      });
      if (res.data.code == 200) {
        if (tableData.list.length == 1 && currentPage.value != 1) {
          currentPage.value = currentPage.value - 1;
        }
        getList();
        store.dispatch("busNum");
        ElMessage({
          type: "success",
          showClose: true,
          message: res.data.message,
          center: true,
        });
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: res.data.message,
          center: true,
        });
      }
      console.log(res);
    })
    .catch(() => {
      ElMessage({
        type: "info",
        message: "已取消删除",
      });
    });
};

// 多选框功能
const handleSelectionChange = (val) => {
  console.log(val);
  selectData.list = val;
};
//导出功能
const importExcel = async () => {
  if (searchInput.createTime == null) {
    searchInput.createTime = "";
  }
  let data = new FormData();
  data.set("car_number", searchInput.carnumber);
  data.set("create_time", searchInput.createTime);
  let res = await axios({
    method: "post",
    url: api.value + "/carBook/cinfotoExcel.action",
    headers: {
      token: sessionStorage.getItem("token"),
    },
    data: data,
  });
  // console.log(res, "导出账号");
  if (res.data.code == 200) {
    // const elt = document.createElement("a");
    // elt.setAttribute(
    //   "href",
    //   "https://car.meiyishuoo.com/ride-sharing" + res.data.downurl
    // );
    // elt.setAttribute("download", "file.png");
    // elt.style.display = "none";
    // document.body.appendChild(elt);
    // elt.click();
    var downloadPath = "https://car.meiyishuoo.com/ride-sharing" + res.data.downurl;
    console.log("获得地址数据:", downloadPath);
    var downloadLink = document.createElement("a");
    downloadLink.style.display = "none"; // 使其隐藏
    downloadLink.href = downloadPath;
    downloadLink.download = "";
    downloadLink.click();
    document.body.appendChild(downloadLink);
    document.body.removeChild(downloadLink);
    ElMessage({
      type: "success",
      showClose: true,
      message: res.data.message,
      center: true,
    });
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.data.message,
      center: true,
    });
  }
};
// 表格斑马纹颜色修改
const tableRowClassName = ({ row, rowIndex }) => {
  if (rowIndex % 2 === 0) {
    return "even";
  } else if (rowIndex % 2 !== 0) {
    return "odd";
  }
  return "";
};
// 分页
const handleCurrentChange = (value) => {
  // console.log(value);
  currentPage.value = value;
  getList();
};

onBeforeMount(() => {
  api.value = store.state.user.api;
  getList();
});
onUnmounted(() => {
  // document.removeEventListener("keyup", Enters);
});
</script>

<style scoped lang="scss">
.content-box {
  width: calc(100% - 40px);
  height: calc(100% - 105px);
  margin: 20px auto;
  background-color: #fff;
  color: #fff;
  display: flex;
  flex-direction: column;

  .left {
    width: calc(100% - 40px);
    display: flex;
    align-items: center;
    height: 60px;
    margin: 0 30px;
    border-bottom: 1px solid #ccc;
    color: #000;
    font-size: 18px;
    font-weight: 600;
    .camera {
      margin-right: 15px;
      color: #4392f7;
    }
  }
  .middle {
    width: calc(100% - 60px);
    margin: 0 auto;

    color: #000;
    // border-bottom: 1px solid rgb(231, 231, 231);
    .filter {
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      margin: 10px 0 0 0;
      .search {
        margin-left: 0 !important;
      }
      .condition {
        display: flex;
        align-items: center;
        margin: 10px 30px 10px 0;
        :deep(.el-input .el-input__inner) {
          font-size: 16px;
        }
        span {
          margin: 0 10px 0 0;
        }
      }
    }
    .gongneng {
      margin: 10px 0;
    }
    :deep(.cont) {
      width: 60%;
      margin: 20px auto;
    }
    :deep(.download) {
      display: flex;
      align-items: center;
      margin: 10px;
    }
    :deep(.download span) {
      font-size: 16px;
      margin-left: 20px;
    }
    :deep(.cont .el-button) {
      margin-left: 60px;
      margin-bottom: 30px;
    }

    :deep(.cont .accomplish) {
      width: 100%;
      display: flex;
      justify-content: center;
    }
    :deep(.cont .accomplish .el-button) {
      width: 50%;
      margin: 0;
    }
  }
  .footer {
    width: calc(100% - 60px);
    flex:1;
    margin: 10px auto 10px;
    overflow: auto;
    .el-table--fit {
      height: 100%;
      :deep(.el-table__header-wrapper) {
        background-color: #000;
        font-size: 16px;
        color: #000;
      }
      :deep(.el-table__row) {
        height: 50px;
        font-size: 16px;
        color: #000;
      }
      :deep(.el-table__row td) {
        padding: 0;
        border: 0;
      }

      .el-button--primary {
        margin-left: 5px;
      }
      :deep(.el-table__body .even) {
        background-color: #fff;
      }
      :deep(.el-table__body .odd) {
        background-color: rgba(240, 243, 247, 1);
      }
      :deep(.look) {
        padding: 5px 10px;
        border-radius: 45px;
        border: 0.74px solid rgba(30, 125, 251, 1);
      }
      :deep(.looks) {
        padding: 5px 10px;
        border-radius: 45px;
        border: 0.74px solid #f56c6c;
      }
    }

    // 添加员工弹窗样式
    :deep(.addStaff) {
      //   height: 420px;
      border-radius: 11px;
      .el-dialog__header {
        border-radius: 11px 11px 0 0;
        background: rgba(237, 241, 245, 1);
        font-weight: 600;
        margin: 0;
        .el-dialog__headerbtn {
          outline: none;
        }
      }
      .el-dialog__body {
        padding: 30px 20px 10px 20px;
        .el-input {
          width: 200px;
        }
        .options {
          margin-left: 320px;
        }
      }
    }
  }
  .el-pagination {
    // width: 1600px;
    width: calc(100% - 60px);
    height: 60px;
    margin: 0 30px;
    justify-content: flex-end;
    :deep(.el-pagination__total) {
      color: #000;
    }
    :deep(.el-pagination__goto) {
      color: #000;
    }
    :deep(.el-pagination__classifier) {
      color: #000;
    }
    :deep(.el-input__wrapper) {
      border: 1px solid rgba(0, 0, 0, 1);
      border-radius: 5px;
      box-shadow: none;
    }
    :deep(.el-pager li) {
      margin: 0 5px;
      border: 1px solid rgba(0, 0, 0, 1);
      border-radius: 5px;
      background-color: transparent;
    }
    :deep(.el-pager li.is-active) {
      background-color: rgba(30, 125, 251, 1);
    }
    :deep(.btn-prev) {
      margin-right: 5px;
      border: 1px solid rgba(0, 0, 0, 1);
      border-radius: 5px;
      background-color: transparent;
    }
    :deep(.btn-next) {
      margin-left: 5px;
      border: 1px solid rgba(0, 0, 0, 1);
      border-radius: 5px;
      background-color: transparent;
    }
  }
}
.el-input {
  width: 192px;
}
</style>
